﻿using Cvicenie02;

void ExampleDeclarations()
{
    Motorbike bike = new Motorbike();
    bike.Name = "bike";
    
    var bike2 = new Motorbike();
    bike2.Name = "bike2";
    
    var bike3 = new Motorbike { Name = "bike3" };

    var bike4 = new Motorbike(10);

    var bike5 = new Motorbike(wheelsCount: 10);

    var bike6 = new Motorbike(wheelsCount: 10) { Name = "Bike6" };

    // A little bit of Magic ;)
    IDriveable bike7 = new Motorbike(wheelsCount: 10) { Name = "Bike7" };
    // results in error -> bike7.Name; ... but why ? ved sme predsa Name setli :Hmmm:
}


// TYPES

// ref

var a = new Motorbike { Name = "Bike1" };
Console.WriteLine(a.Name);
ChangeBike(a);
Console.WriteLine(a.Name);
ChangeBikeRef(ref a);
// Motorbike x = null;  ChangeBikeRef(ref x);    <- this bad (ref nesmie byt null !)
Console.WriteLine(a.Name);

void ChangeBike(Motorbike mb)
{
    mb = new Motorbike { Name = "Bike2" };
}

void ChangeBikeRef(ref Motorbike mb)
{
    mb = new Motorbike { Name = "Bike2" };
}

Console.ReadKey();
Console.WriteLine("---------------------------------------");

// out

var motorBike = new Motorbike { Name = "Bike1" };
Console.WriteLine(motorBike.Name);
bool bb = GiveBikeWithoutOut(motorBike);
Console.WriteLine(motorBike.Name, bb);
bb = GiveBikeWithOut(out motorBike);
Console.WriteLine(motorBike.Name, bb);

bool GiveBikeWithoutOut(Motorbike mb)
{
    mb = new Motorbike { Name = "Bike2" };
    return false;
}

bool GiveBikeWithOut(out Motorbike mb)
{
    // -> mb.Name = "hello";
    mb = new Motorbike { Name = "Bike-out" };
    return false;
}


Console.ReadKey();
Console.WriteLine("---------------------------------------");

// Value Type

var nh = new NumberHolder();
nh.Number = 10;

Console.WriteLine(nh.Number);
ChangeValType(nh);
Console.WriteLine(nh.Number);

void ChangeValType(NumberHolder nh)
{
    nh.Number = 22;
}

Console.ReadKey();
Console.WriteLine("---------------------------------------");

// Reference Type Variables

var refBike = new Motorbike { Name = "Zidan" };

Console.WriteLine(refBike.Name);
ChangeRefType(refBike);
Console.WriteLine(refBike.Name);

void ChangeRefType(Motorbike mb)
{
    mb.Name = "Red";
}


Console.ReadKey();
Console.WriteLine("---------------------------------------");
// new (override) example

var car = new Car();
var bus = new Bus();

car.NumberOfSeats();
bus.NumberOfSeats();

Console.ReadKey();
Console.WriteLine("---------------------------------------");
// Nullable

var number = 10;
int? number2 = null; // zde nefunguje implicitni typovani pomoci var
                     // null coalescing operator priradi hodnotu 10
var notNullableNumber = number2 ?? number;  // ak je number2 null (nema hodnotu) tak tam prirad number
                                            // na pozadi -> x = (y != null ? y : z);
                                            // https://stackoverflow.com/questions/1608174/what-does-a-double-question-mark-do-in-c
// 5 bude defaultni hodnota  
Console.WriteLine(notNullableNumber);
notNullableNumber = number2.GetValueOrDefault(5);
Console.WriteLine(notNullableNumber);
// alebo trosku menej citatelne 
notNullableNumber = number2 ?? 6;
Console.WriteLine(notNullableNumber);

number2 = notNullableNumber;
// dalsi moznost zjisteni hodnoty (maji vsechny nullable typy, viz odkaz)
if (number2.HasValue)
{
    // nelze prevest int? na int
    // notNullableNumber = number2 
    // konverzi lze provest naprimo skrze property value (viz dale)
    notNullableNumber = number2.Value;
    Console.WriteLine(notNullableNumber);
}

// plz dont
string? x = null;
Motorbike? y = null;


// Enum Casting
void EnumCasting()
{
    var color = Color.Green;

    var colorString = color.ToString();

    color = (Color) Enum.Parse(typeof(Color), colorString);          // case sensitive variant
    color = (Color) Enum.Parse(typeof(Color), colorString, true);    // case insensitive variant
    // -> better ofc -> Enum.TryParse(colorString, out color);
    // Enum.TryParse(colorString, true, out color);
}